<?php
/**
*	@Copyright Copyright (C) 2011 Roman Gelembjuk <roman@gelembjuk.com>
*	@license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*
*	This file is part of Google Finance Currencies module for Joomla .
*
*	Google Finance Currencies module for Joomla is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	Google Finance Currencies module for Joomla is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with Google Finance Currencies module for Joomla.  If not, see <http://www.gnu.org/licenses/>.
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modGSCurrenciesHelper
{
	function getData(&$params)
	{
		$html=modGSCurrenciesHelper::get_page('http://news4trader.com/static/google_finance_currencies.htm');		
		return $html;
	}

	function  loadData(&$params){
	      $cachefile=JPATH_CACHE.DS.'google_finance_currencies.htm';
	      
	      $usecache=$params->get('use_cache', '');
	      
	      if($usecache=='1' && !is_writable(JPATH_CACHE)){
	       	       $usecache=0;
	      }
	      
	      if($usecache=='1'){
	      	      $cachetime=intval($params->get('cachetime', '5'));
	      	      if($cachetime==0) $cachetime=5;
	      	      if(file_exists($cachefile)){
	      	      	      if(time()-filectime($cachefile)<$cachetime*60){
	      	      	      	      return file_get_contents($cachefile);
	      	      	      }
	      	      }
	      }
	      
	      $html = modGSCurrenciesHelper::getData($params);
	      
	      if($usecache=='1'){
	      	      file_put_contents($cachefile,$html);
	      }
	      return $html;
	}

	function get_page($url,$lim=15) {
		$agent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)";

		if(function_exists('curl_init')){
			  $ch = curl_init();
			  curl_setopt($ch, CURLOPT_URL, $url);
			  curl_setopt($ch, CURLOPT_USERAGENT, $agent);
			  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			  curl_setopt($ch, CURLOPT_TIMEOUT, $lim);
			  curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 3);
    	
			  $result = curl_exec ($ch);

			  if (curl_error($ch)) { 
				      $result="";
			  } 

			curl_close ($ch);
		}else{
			  $result=file_get_contents($url);
		}
		return $result;
	}
}